
#include <poll.h>
#include <sys/queue.h>

struct phkev;
struct phkev__;
struct phkevbase;

typedef int phkev_cb_f(struct phkev *, int what);

struct phkev {
	unsigned	magic;
#define PHKEV_MAGIC	0x15c8134b

	/* pub */
	const char	*name;
	int		fd;
	unsigned	fd_flags;
#define		EV_RD	POLLIN
#define		EV_WR	POLLOUT
#define		EV_ERR	POLLERR
#define		EV_HUP	POLLHUP
#define		EV_SIG	-1
	int		sig;
	unsigned	sig_flags;
	double		timeout;
	phkev_cb_f	*callback;
	void		*priv;

	/* Private, don't touch */
	struct phkev__	*real;
};

struct phkevbase *PhkEvNewBase(void);
void PhkEvDestroyBase(struct phkevbase *evb);

struct phkev *PhkEvNew(void);

int PhkEvAdd(struct phkevbase *evb, struct phkev *e);
void PhkEvDel(struct phkevbase *evb, struct phkev *e);

int PhkEvSchedOne(struct phkevbase *evb);
int PhkEvSched(struct phkevbase *evb);
